#define BLOCK_SIZE 	16			// submatrix size
#define	N			1024		// matrix size is N*N

__global__ void matMult ( float * a, float * b, int n, float * c )
{
	int   bx  = blockIdx.x;		// block index
	int   by  = blockIdx.y;
	int   tx  = threadIdx.x;		// thread index
	int   ty  = threadIdx.y;
	float sum = 0.0f;			// computed subelement
	int	  ia  = n * BLOCK_SIZE * by + n * ty;	// a [i][0]
	int   ib  = BLOCK_SIZE * bx + tx;
	
							// Multiply the two matrices together;
	for ( int k = 0; k < n; k++ )
		sum += a [ia + k] * b [ib + k*n];
			
							// Write the block sub-matrix to global memory;
							// each thread writes one element
	int ic = n * BLOCK_SIZE * by + BLOCK_SIZE * bx;
	
	c [ic + n * ty + tx] = sum;
}
